<?php
/*
xAjax est une librairie open source toujours en développement, qui permet de déployer des applications AJAX puissantes très facilement en ayant des bases de PHP. AJAX signifie Asynchronous Javascript And XML : ce type d'application permet d'exécuter des fonctions php de manière dynamique, sans que la page ait besoin d'être rechargée.
*/

//Connexion à la BDD
		include "[chemin absolu]/chat/connexion_bdd.php"; /*MODIFIEZ CETTE LIGNE*/

// La fonction d'affichage des messages
function afficher()
{
		session_start(); //Ouverture des sessions
        $reponse = new xajaxResponse(); //Instanciation de la classe xajax
		include('[chemin absolu]/chat/connexion_bdd.php'); //Connexion à la bdd MODIFIEZ CETTE LIGNE
		include('[chemin absolu]/chat/smileys.php'); //Inclusion de la fonction de conversion de smileys MODIFIEZ CETTE LIGNE
		
		//REQUÊTE DES 30 DERNIERS MESSAGES
		$req = $bdd->query('SELECT posteur, contenu, DATE_FORMAT(date, \'%d-%m %H:%i\') AS date_fr FROM tchat ORDER BY id DESC LIMIT 0 , 30'); /*REMPLACER "tchat" par le nom de votre table des messages*/
        while ($data = $req->fetch())
		{
			$data['contenu'] = smileys($data['contenu']); //transformation des smileys
			$chat .= '['.$data['date_fr'].']<strong style="color:#095197">&lt;'.$data['posteur'].'&gt;</strong> '.stripslashes(nl2br($data['contenu'])).'<br />'; //Concaténation de la variable à chaque passage de la boucle.
		}
		$req->closeCursor();

		// AJOUT A LA TABLE DES PRESENTS
		$reqPresent = $bdd->prepare('SELECT COUNT(nom) AS nb FROM tchat_presence WHERE nom = ?'); // On test si l'utilisateur est déjà inscrit dans la bdd /*REMPLACER "tchat_presence" par le nom de votre table de présence*/
		$reqPresent->execute(array($_SESSION['loginchat']));
		$dataPresent = $reqPresent->fetch();
		$reqPresent->closeCursor();
		if ($dataPresent['nb'] == 0) { //Si ce n'est pas le cas alors
			$reqPresence = $bdd->prepare('INSERT INTO tchat_presence(nom, timestamp) VALUES(?, ?)'); //On l'y ajoute /*REMPLACER "tchat_presence" par le nom de votre table de présence*/
			$reqPresence->execute(array($_SESSION['loginchat'], time()));
		}
		else {
			$reqPresence = $bdd->prepare('UPDATE tchat_presence SET timestamp = ? WHERE nom = ?'); //Sinon on met à jour sa présence /*REMPLACER "tchat_presence" par le nom de votre table de présence*/
			$reqPresence->execute(array(time(), $_SESSION['loginchat']));
		}
		
		// BIP A LA RECEPTION D'UN NOUVEAU MESSAGE
		if(isset($_SESSION['sound']) && $_SESSION['sound'] == 1) { //Si le son est activé
			$req2 = $bdd->query('SELECT COUNT(id) id_max FROM tchat'); //On vérifie le nombre de messages dans la table /*REMPLACER "tchat" par le nom de votre table des messages*/
			$data2 = $req2->fetch();
			if($data2['id_max'] != $_SESSION['id_max'] || !isset($_SESSION['id_max'])) { //Si il est différent de la variable de session, on joue le son de notification
				$reponse->script("document.getElementById('nv_message').play()");			
			}
			$_SESSION['id_max'] = $data2['id_max'];
			$req2->closeCursor();
		}
		
		// AFFICHAGE
        $reponse->clear('Tchatblock', 'innerHTML');
        $reponse->assign('Tchatblock', 'innerHTML', $chat);
        return $reponse;
}

//sound ON ou OFF
function setsound($bool_sound) {
	$reponse = new xajaxResponse();
	$_SESSION['sound'] = $bool_sound; //On active ou désactive le son en fonction de la checkbox (cochée ou non)
	$on = "<span style='color:black; margin-left:10px; width:90px;'><img src='/guigre/chat/sound_on.png' title='Son activé'/> Son activé</span>"; //Si le son est activé, on le signale dans la barre d'information
	$off = "<span style='color:black; margin-left:10px; width:90px;'><img src='/guigre/chat/sound_off.png' title='Son sésactivé'/> Son désactivé</span>"; // Si le son est désactivé, on le signale aussi
	if($bool_sound == 1) {
		$reponse->assign('soundornot', 'innerHTML', $on);
	}
	if($bool_sound == 0) {
		$reponse->assign('soundornot', 'innerHTML', $off);
	}
	return $reponse;
}

// liste des pers. sur le tchat
function presents()
{
	$reponse = new xajaxResponse();
	include('[chemin absolu]/chat/connexion_bdd.php'); /*MODIFIEZ CETTE LIGNE*/
	$timestampLimit = time() - 5;
	
	$reqSuppr = $bdd->exec('DELETE FROM tchat_presence WHERE timestamp < '.$timestampLimit); //On supprime les entrées innactives depuis plus de 5 secondes /*REMPLACER "tchat_presence" par le nom de votre table de présence*/
	
	$req = $bdd->query('SELECT nom FROM tchat_presence ORDER BY nom'); //On récupère les entrées de la table /*REMPLACER "tchat_presence" par le nom de votre table de présence*/
	
	while ($noms = $req->fetch()) //On créé une variable contenant les noms
	{
		if (empty($liste))
			$liste = $noms['nom'];
		else
			$liste .= ', '.$noms['nom'];
	}
	$req->closeCursor();
	
	$reponse->assign('presents', 'innerHTML', $liste); //On assigne la variable au champ correspondant
    return $reponse;
}

//ajout du message dans la bdd
function envoyer($donnees_formulaire)
{
	if ($donnees_formulaire['message'] == "") { //Si il y a bien un message
        $reponse->script('alert("Il vous faut un message !");');
	}
	else {
        $reponse = new xajaxResponse();
		include('[chemin absolu]/chat/connexion_bdd.php'); //Connexion à la Bdd MODIFIEZ CETTE LIGNE
		$donnees_formulaire['message'] = addslashes(htmlspecialchars($donnees_formulaire['message'])); //On formate les données pour éviter les petits malin
		$donnees_formulaire['message'] = preg_replace('#http://[a-zA-Z0-9.\#|,_/\\-?+=~&;%]+#i', '<a href="$0" target="_blank">$0</a>', $donnees_formulaire['message']); //On ajoute les liens
		$donnees_formulaire['message'] = preg_replace('#\[b\](.+)\[/b\]#isU', '<strong>$1</strong>', $donnees_formulaire['message']); //On ajoute le gras
		$donnees_formulaire['message'] = preg_replace('#\[i\](.+)\[/i\]#isU', '<span style="font-style:italic;">$1</span>', $donnees_formulaire['message']); //On ajoute l'italique
		$donnees_formulaire['message'] = preg_replace('#\[u\](.+)\[/u\]#isU', '<span style="text-decoration:underline;">$1</span>', $donnees_formulaire['message']); //On ajoute le soulignement
		$req = $bdd->prepare("INSERT INTO tchat (posteur,contenu,date) VALUES (?,?, NOW())"); //On ajoute le message à la Bdd /*REMPLACER "tchat" par le nom de votre table des messages*/
		$req->execute(array($_SESSION['loginchat'], $donnees_formulaire['message']));
		$reponse->clear('message', 'value');
        $reponse->call('xajax_afficher');
        return $reponse;
	}
}
require('[chemin absolu]/chat/xajax/xajax_core/xajax.inc.php'); /*MODIFIEZ CETTE LIGNE*/
$xajax = new xajax();
//On enregistre les fonctions pour qu'elles soient utilisables en JS.
$xajax->register(XAJAX_FUNCTION, 'afficher');
$xajax->register(XAJAX_FUNCTION, 'setsound');
$xajax->register(XAJAX_FUNCTION, 'envoyer');
$xajax->register(XAJAX_FUNCTION, 'presents');
$xajax->processRequest();
?>